#!/usr/bin/python
# Partly copyright Martin T. Sandsmark <martin.sandsmark@gmail.com>
#  http://phinn.christian.net/
#
#Lots of code stolen from the 
# TTS script for amarok by Paul Giannaros <ceruleanblaze@gmail.com>
# and therefore partly copyright him.

import time
import commands
import subprocess

def setText(text):
    """ Speak some text via DCOP synchronously. """
    # Use subprocess.Popen to prevent any funkiness with shell meta characters.
    job = subprocess.Popen(["dcop", "kopete", "KopeteIface", "setAway", "%s" % text.replace("'", "\\'"), "1"], stdout=subprocess.PIPE).communicate()[0]
    time.sleep(0.5)

def configAsDict():
    """ Returns the configuration file as a dictionary of key->value """
    f = file("koparokrc")
    text = f.read().strip()
    f.close()
    return dict([line.split("=", 1) for line in text.splitlines() if line and not line.startswith("#")])

def writeConfigFromDict(d):
    """ Write the configuration file given a dict of keys->value """
    f = file("koparokrc", "w")
    output = ""
    for keyvalue in d.items():
        output += "%s=%s\n" % keyvalue
    f.write(output)
    f.close()

def formatTrack():
    """ Return the text to speek from the config file using SSML for some breaks """
    string = configAsDict()["Text"]
    string = string.replace("%a", commands.getoutput("dcop amarok player artist")).replace("%t", commands.getoutput("dcop amarok player title")).replace("%l", commands.getoutput("dcop amarok player totalTime")).replace("%b", commands.getoutput("dcop amarok player album"))
    return string

def configure():
    """ Show a configure dialog that allows the user to customize
    the spoken text. """
    config = configAsDict()
    text = subprocess.Popen(["kdialog", "--title", "amaroK Kopete script - configuration", "--inputbox", "Text .\n    Can include any of the following metacharacters:\n\n%a - artist\n%t - title\n%b - album\n%l - length", "%s" % config["Text"]], stdout=subprocess.PIPE).communicate()[0]
    # If cancel was not pressed update the conf.
    print text
    if not text == "\n":
        config["Text"] = text
    writeConfigFromDict(config)

def main():
    # Start Kopete if it's not running
    if not "kopete" in [proc[proc.rfind(" ") + 1:] for proc in commands.getoutput("ps -A").split("\n")]:
        subprocess.Popen("kopete")
    # Make sure the config file exists
    try:
        f = file("koparokrc")
        if not f.read():
            raise IOError
        f.close()
    except IOError:
        f = file("koparokrc", "w")
        f.write(r"Text=amaroK is now playing: %t by %a")
        f.close()
    # Event loop
    while True:
        command = raw_input()
        if command == "configure":
            configure()
        if command == "trackChange":
            setText(formatTrack())
if __name__ == "__main__":
    main()
